#!/usr/bin/python

import dbus, gobject, sys, signal, os
from dbus.mainloop.glib import DBusGMainLoop
import dbus.service

from nm_constants import *

from CeibalSCALog import *
from inspect import currentframe

PID_FILE = "/var/run/CeibalSCAd/CeibalSCA_NM_disp.pid"


class CeibalSCASignal(dbus.service.Object):
    def __init__(self, bus_name):
        dbus.service.Object.__init__(self, bus_name, CEIBALSCA_DBUS_PATH)

    @dbus.service.signal(dbus_interface=CEIBALSCA_DBUS_INTERFACE, signature='u')
    def StateChange(self, state):
        pass


def nm_connected(sig_number, frame):
    global s
    s.StateChange(NM_STATE_CONNECTED)

def nm_disconnected(sig_number, frame):
    global s
    s.StateChange(NM_STATE_DISCONNECTED)

# Set pid in PID_FILE
f = open (PID_FILE, 'w')
f.write (str(os.getpid()))
f.close()

# Set up DBUS signal
global s
DBusGMainLoop(set_as_default=True)
session_bus = dbus.SystemBus()
bus_name = dbus.service.BusName(CEIBALSCA_DBUS_SERVICE, bus=session_bus)
s = CeibalSCASignal(bus_name)

# Manage system signals
signal.signal(signal.SIGUSR1, nm_connected)
signal.signal(signal.SIGUSR2, nm_disconnected)

mainloop = gobject.MainLoop()
mainloop.run()
